(function () {
	var extensionForm = $("#extensions_form");
	var attach_toggle = $("#extensions_form #extensionsvoicemail input#attach");
	var delete_toggle = $("#extensions_form #extensionsvoicemail input#delete");
	var notifications_toggle = $("#extensions_form #extensionsvoicemail input#notifications");
	var notifications_toggle_labels = $("#extensions_form #extensionsvoicemail div.form-group-notifications label");
	var delete_toggle_labels = $("#extensions_form #extensionsvoicemail div.form-group-delete label");
	var new_extension = (extensionForm.find("[name='extension_id']").val() == "");
	var portal_user_is_extension_number = (extensionForm.find("[name='extension']").val() == extensionForm.find("#portal_user").val());
	extensionForm.validate(Validations);
	var getEditExtensionMode = function (id) {
		pbx_request("extensions", "getContent", "edit", id);
	};
	if(extensionForm.find("[name='mode']").val() != 'edit') {
		extensionForm.find("[name='extension']").autocomplete({
				source : extAutoComplete,
				select : function (event, ui) {
					getEditExtensionMode(ui.item.id);
				}
			});
	}
	extensionForm.on("focusout", "[name='extension']", function () {
		if(extensionForm.find("[name='mode']").val() != 'edit') {
			var extension = $(this).val();
			if (extensions[extension] !== undefined) {
				getEditExtensionMode(extensions[extension]);
			}
		}
	}).on("keyup", "[name='extension']", function() {
		var extension = $(this).val();
		if (new_extension) {
			extensionForm.find("#sip-user, #iax-user, #vm_password").val(extension);
		}
		if (portal_user_is_extension_number) {
			extensionForm.find("#portal_user").val(extension);
		}
	}).on("keyup", "[name='name']", function() {
		extensionForm.find("#dev-description").val($(this).val());
	});
	extensionForm.on("keyup", "input[name$='-secret'], input[name='portal_password']", function() {
		show_pass_strength({
			"class" : "core",
			"method" : "show_strength",
			"value" : this.value,
			"bar_selector" : "#extensions_form [name='"+this.name+"'] + .password_strength"
		});
	});

	extensionForm.find('.gen_send_password').on("click", function() {
		var extension_id = extensionForm.find("[name='extension_id']").val();
		pbx_request("extensions", "gen_send_password", "edit",
			JSON.stringify({
				extension_id: extension_id,
				portal_user: extensionForm.find("#portal_user").val(),
				baseurl: window.location.protocol + "//" + window.location.host,
			})
		);
	});

	var update_cloudphone_hostname_warning = function() {
		var technology = extensionForm.find("[name='technology']:checked").val();
		if (!technology) {
			technology = extensionForm.find("[name='technology']").val();
		}
		if (technology != "cloudphone" || $("#cloudphone-profile_id :selected").data('has-hostname')) {
			$(".form-group-cloudphone-warning").hide();
		} else {
			$(".form-group-cloudphone-warning").show();
		}
	}

	$("#cloudphone-profile_id").change(update_cloudphone_hostname_warning);

	var change_technology = function () {
		var technology = extensionForm.find("[name='technology']:checked").val();
		if (!technology) {
			technology = extensionForm.find("[name='technology']").val();
		}
		var device_form = extensionForm.find(".device-form").show();
		device_form.find(".form-group").hide();
		device_form.find("[name^='"+technology+"-'],[name^='dev-']").closest(".form-group").show();
		if (technology == "none") {
			device_form.hide();
		}

		var device_id = extensionForm.find("[name='device_id']").val();
		if ((typeof device_id != "undefined" && device_id == "new")) { //if new device -> no buttons
			extensionForm.find(
				"button.frmactions-unlink-device, \
				button.frmactions-remove-device").
			hide();
		} else if(technology == "mobile" || technology == "custom" || technology == "cloudphone") {
			extensionForm.find("button.frmactions-unlink-device").hide();
			extensionForm.find("button.frmactions-remove-device").show();
			extensionForm.find('#cloudphone-send_qrcode').on("click", function() {
				BootstrapDialog.show({
					type: BootstrapDialog.TYPE_WARNING,
					title: strings.warning,
					message: strings.qr_code_reset_warning,
					buttons: [{
						label: strings.confirm,
						cssClass: 'btn-warning',
						action: function(dialog) {
							dialog.close();
							var extension_id = extensionForm.find('#extensionsgeneral input#extension_id').val();
							pbx_request("extensions", "gen_send_qrcode", "edit",
								JSON.stringify({
									extension_id: extension_id,
									baseurl: window.location.protocol + "//" + window.location.host,
								})
							).then(function(reply) {
								extensionForm.find("#cloudphone-qrcode")
									.attr("src", "data:image/png;base64,"+reply["qr-code"]);
							});
						}
					}, {
						label: strings.cancel,
						cssClass: 'btn-primary',
						action: function(dialog) {
							dialog.close();
						}
					}]
				});
			});
		} else {
			extensionForm.find("button.frmactions-remove-device").hide();
			extensionForm.find("button.frmactions-unlink-device").show();
		}
		extensionForm.find("input#"+technology+"-secret").trigger("keyup");
		update_cloudphone_hostname_warning(technology);
	};
	// prevent setting attaching vm without notify
	// or setting deleting vm without attaching
	var set_restrictions = function() {
		if(!attach_toggle.prop('checked')) {
			delete_toggle.bootstrapToggle('off');
		} else {
			notifications_toggle.bootstrapToggle('on');
		}
		gray_out(attach_toggle, notifications_toggle, notifications_toggle_labels, true);
		gray_out(attach_toggle,delete_toggle,delete_toggle_labels);
	}
	extensionForm.on("change", "[name='device_id']", function () {
		var device_id = $(this).val();
		var extension_id = extensionForm.find("[name='extension_id']").val();
		pbx_request("extensions", "getDevice", "edit", device_id + "|" + extension_id, null, false)
			.done(change_technology);
	});
	extensionForm.on("change", "[name='technology']", change_technology);
	extensionForm.find(
		"button.frmactions-remove-device, \
		button.frmactions-unlink-device"
		).
	on("click", function() {
		var device_id = extensionForm.find("[name='device_id']").val();
		pbx_request("extensions", "unlink", "delete", device_id);
	});
	change_technology();
	$("#extensions_form #extensionsvoicemail input#attach").on('change', function() {
		set_restrictions();
	});
	set_restrictions();
	extensionForm.submit(function() {
		notifications_toggle.prop('disabled', false);
		delete_toggle.prop('disabled', false);
	})

	// prevent portal password generation via dedicated button
	// if portal user is disabled
	var portal_toggle = $("#extensions_form #extensionsadvanced input#enable_portal");
	var gen_passwod_button = $("#extensions_form #extensionsadvanced button.gen_send_password");
	gray_out(portal_toggle, gen_passwod_button);
	portal_toggle.on('change', function() {
		gray_out(portal_toggle, gen_passwod_button);
	});
})();
